#!/usr/local/bin/python

# Script:  rerun.py
# Purpose: rerun snapshots from a LAMMPS dump file thru LAMMPS
# Syntax:  rerun.py dumpfile datafile
#          dumpfile = LAMMPS dump file in native LAMMPS format
# Author:  Steve Plimpton (Sandia), sjplimp at sandia.gov

import sys,os,commands
path = os.environ["LAMMPS_PYTHON_TOOLS"]
sys.path.append(path)
from dump import dump
from data import data

if len(sys.argv) != 4:
  raise StandardError, "Syntax: rerun.py dumpfile inputfile datafile"

# need to identify columns in dump and data file for x,y,z,ix,iy,iz
# maybe also id,type
# put reset timestep command in in.script via variable
# how to keep datafile from being renamed (and disappearing)
#   if LAMMPS or script croaks part way thru
#   could require new script to read a different data file?
# what about velocities for KE, temp? - need to be in dump file?

dumpfile = sys.argv[1]    # should just read one snap at a time
infile = sys.argv[2]
datafile = sys.argv[3]

dm = dump(dumpfile)
dt = data(datafile)
dt.map(1,"id",2,"type",4,"x",5,"y",6,"z")

os.rename(datafile,"tmp.data")

dt.newxyz(dm,0)
dt.write(datafile)
print commands.getoutput("lmp_linux < %s" % infile)
commands.getoutput("mv log.lammps log.0")

dt.newxyz(dm,100)
dt.write(datafile)
print commands.getoutput("lmp_linux < %s" % infile)
commands.getoutput("mv log.lammps log.100")

dt.newxyz(dm,1000)
dt.write(datafile)
print commands.getoutput("lmp_linux < %s" % infile)
commands.getoutput("mv log.lammps log.1000")

os.rename("tmp.data",datafile)
